#!/bin/bash
# SQLUX Config GUI 
# dependencies yad 

clear  

if ! [ -x "$(command -v yad)" ]; then
  echo 'Error: yad is not installed.' >&2
  exit 1
#else
# currentver="$(yad --version)"
# requiredver="14.0"
#if [ "$(printf '%s\n' "$requiredver" "$currentver" | sort -V | head -n1)" != "$requiredver" # ]; then 
#  yad --text="Version 14.x required \n please update your yad version \n from https://
#  github.com/v1cont/yad" --text-align=center  
# exit 1
# fi
fi

declare -a select 
declare -a afirst
declare -a alast
declare -i z
declare -i height
declare -i width
declare -i iheight
declare -i aheight
declare -i iwidth
declare -i awidth
declare -i rams
#declare -i filter
#declare -i ascpect
#declare -i sound

read width height < <(xrandr --current | grep -oP '\d+x\d+' | tr x ' ')
#echo $width $height
if [ $width -gt $height ]; then
#echo "Landscape"
iheight=(height/32)
aheight=(iheight*10)
iwidth=(width/32)
awidth=(iwidth*10)
else
#echo "Portrait"
aheight=(height/3)
awidth=(width/2)
fi
resmax=$awidth'x'$aheight
#echo $resmax

ini=~/sqlux.ini
init="~/sqlux.ini"
PRODIR="~/sQLux/build"
rams=512

expand_tilde()
{
    case "$1" in
    (\~)        echo "$HOME";;
    (\~/*)      echo "$HOME/${1#\~/}";;
    (\~[^/]*/*) local user=$(eval echo ${1%%/*})
                echo "$user/${1#*/}";;
    (\~[^/]*)   eval echo ${1};;
    (*)         echo "$1";;
    esac
}

function BSEL() {
while : ; do
FILE="$(yad --form --separator='\n' \
	--text_info --title="Select File  ""*.$1 *.$2" \
    --width=500 --height=100 \
    --field=" ":FL \
    --file-filter "*.$1 *.$2" 
	)" ret=$? 
[[ $ret -eq 1 ]] && exit
if [[ -f "$FILE" ]]; then
break
fi
done
printf "%s\n" "$3:$FILE" | sed "s/${HOME//\//\\\/}/~/"
}
export -f BSEL

function BDIR () {
while : ; do
DIRE="$(yad --form --separator='\n' \
	--text_info --title="Select Directory" \
	--width=500 --height=100 \
    --field=" ":DIR 
    )" ret=$?
[[ $ret -eq 1 ]] && exit
if [[ -d "$DIRE" ]]; then
break
fi
done
printf "%s\n" "$1:$DIRE" | sed "s/${HOME//\//\\\/}/~/"
}
export -f BDIR


if [ ! -f "$ini" ]; then
cat << EOF > $ini
ROMDIR = ~/sQLux/roms
SYSROM = Minerva_1.98a1.bin
ROMIM = TK236.rom
RAMTOP = 4096
MDV1 = MDV1,~/sQLux/examples/mdv1,qdos-like
MDV2 = MDV2,~/sQLux/examples/mdv2,qdos-like
#FLP1 =
#FLP2 =
#WIN1 =
#WIN2 =
#WIN7 =
#WIN8 =
BOOT_DEVICE = MDV1
RESOLUTION = 512x256
WIN_SIZE = 2x
KBD = US
FILTER = 1
FIXASPECT = 1
SOUND = 1 
CPU_HOG = 0
PRODIR = $PRODIR
EOF
fi

readarray -t select < $ini

z=0
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]##*= } )
romdir=${alast[z]}
else 
afirst[z]='ROMDIR'
fi
echo $z ${afirst[z]} ${alast[z]}

z=1
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]#*=} )
alast[z]=${alast[z]}
else 
afirst[z]='SYSROM'
fi
echo $z:${afirst[z]} ${alast[z]}:

z=2
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]#*=} )
alast[z]=${alast[z]}
else 
afirst[z]='ROMIM'
fi
echo $z:${afirst[z]} ${alast[z]}:

z=3
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]##*=} )
else
afirst[z]='RAMTOP'
fi
echo $z ${afirst[z]} ${alast[z]}

z=4
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='MDV1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}:

z=5
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='MDV2'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}:

z=6
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='FLP1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}:

z=7
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='FLP2'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}:

z=8
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}:

z=9
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN2'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}:

z=10
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN7'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}:

z=11
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN8'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}:

z=12
afirst[z]=$( echo ${select[z]%=*} )
boot1=$(echo ${select[z]##*= } )
boot=$(echo $boot1\!MDV1\!FLP1\!WIN1 )
echo $z  ${afirst[z]} $boot1

z=13
afirst[z]=$( echo ${select[z]%=*} )
res1=$( echo ${select[z]##*= } )
res=$( echo $res1\!512x256\!512x512\!640x400\!960x620!$resmax )
echo $z  ${afirst[z]} $res1

z=14
afirst[z]=$( echo ${select[z]%=*} )
size1=$( echo ${select[z]##*= } )
size=$( echo $size1\!1x\!2x\!3x\!max\!full )
echo $z  ${afirst[z]} $size1

z=15
afirst[z]=$( echo ${select[z]%=*} )
lang1=$( echo ${select[z]##*= } )
lang=$( echo $lang1\!GB\!US\!DE_ch\!DE\!ES )
echo $z  ${afirst[z]} $lang1

z=16
afirst[z]=$( echo ${select[z]%=*} )
filter=$( echo ${select[z]##*= } )
if [[ $filter = '0' ]];then
filter='FALSE'
elif [[ $filter = '1' ]];then
filter='TRUE'
fi
echo $z  ${afirst[z]} $filter

z=17
afirst[z]=$( echo ${select[z]%=*} )
aspect=$( echo ${select[z]##*= } )
if [[ $aspect = '0' ]];then
aspect='FALSE'
elif [[ $aspect = '1' ]];then
aspect='TRUE'
fi
echo $z  ${afirst[z]} $aspect

z=18
afirst[z]=$( echo ${select[z]%=*} )
sound=$( echo ${select[z]##*= } )
if [[ $sound = '0' ]];then
sound='FALSE'
elif [[ $sound = '1' ]];then
sound='TRUE'
fi
echo $z  ${afirst[z]} $sound

z=19
afirst[z]=$( echo ${select[z]%=*} )
cpu_hog=$( echo ${select[z]##*= } )
if [[ $cpu_hog = '0' ]];then
cpu_hog='FALSE'
elif [[ $cpu_hog = '1' ]];then
cpu_hog='TRUE'
fi
echo $z  ${afirst[z]} $cpu_hog

z=20
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]#*=} )
alast[z]=${alast[z]}
else 
afirst[z]='PRODIR'
fi
echo $z:${afirst[z]} ${alast[z]}:

#--bool-fmt=0
#--image=~/sQLux/sQLuxLogo.png \
#--field='':LBL'' \
#--field= ${alast[11]}''\

yad	--form --separator='\n' --columns=2 \
	--text_info --title="uQLx Config ""$init" \
	--geometry=500x500x100x100 \
	--field= "${alast[0]}"\
	--field= "${alast[1]}"\
	--field= "${alast[2]}"\
	--field=' ':NUM ${alast[3]}!512..16000!512\
	--field= "${alast[4]}"\
	--field= "${alast[5]}"\
 	--field= "${alast[6]}"\
 	--field= "${alast[7]}"\
	--field= "${alast[8]}"\
	--field= "${alast[9]}"\
	--field= "${alast[10]}"\
	--field= "${alast[11]}"\
	--field='':CBE $boot\
	--field='':CBE $res\
	--field='':CBE $size\
	--field='':CBE $lang\
	--field= "${alast[20]}"\
	--field=${afirst[0]}:FBTN "@bash -c 'BDIR 1'"\
	--field=${afirst[1]}:FBTN "@bash -c 'BSEL rom bin 2'"\
	--field=${afirst[2]}:FBTN "@bash -c 'BSEL rom bin 3'"\
    --field='':LBL ''\
	--field=${afirst[4]}:FBTN "@bash -c 'BDIR 5'"\
	--field=${afirst[5]}:FBTN "@bash -c 'BDIR 6'"\
	--field=${afirst[6]}:FBTN "@bash -c 'BSEL img IMG 7'"\
	--field=${afirst[7]}:FBTN "@bash -c 'BSEL img IMG 8'"\
	--field=${afirst[8]}:FBTN "@bash -c 'BSEL win WIN 9'"\
	--field=${afirst[9]}:FBTN "@bash -c 'BSEL win WIN 10'"\
	--field=${afirst[10]}:FBTN "@bash -c 'BDIR 11'"\
	--field=${afirst[11]}:FBTN "@bash -c 'BDIR 12'"\
	--field=' FILTER':CHK $filter\
	--field=' FIXASPECT':CHK $aspect\
	--field=' SOUND':CHK $sound\
	--field=' CPU_HOG':CHK $cpu_hog\
	--field=' PATH to sqlux':FBTN "@bash -c 'BDIR 17'" > /tmp/test.txt
	ret=$?
[[ $ret -eq 1 ]] && exit
[[ $ret -eq 252 ]] && exit

readarray -t select < /tmp/test.txt 

echo
echo '0 '  ${select[0]}
echo '1 '  ${select[1]}
echo '2 '  ${select[2]}
echo '3 '  ${select[3]}
echo '4 '  ${select[4]}
echo '5 '  ${select[5]}
echo '6 '  ${select[6]}
echo '7 '  ${select[7]}
echo '8 '  ${select[8]}
echo '9 '  ${select[9]}
echo '10' ${select[10]}
echo '11' ${select[11]}
echo '12' ${select[12]}
echo '13' ${select[13]}
echo '14' ${select[14]}
echo '15' ${select[15]}
echo '16' ${select[16]}
echo '17' ${select[17]}
echo '18' ${select[18]}
echo '19' ${select[19]}
echo '20' ${select[20]}
echo '21' ${select[21]}
echo '22' ${select[22]}
echo '23' ${select[23]}
echo '24' ${select[24]}
echo '25' ${select[25]}
echo '26' ${select[26]}
echo '27' ${select[27]}
echo '28' ${select[28]}
echo '29' ${select[29]}
echo '30' ${select[30]}
echo '31' ${select[31]}
echo '32' ${select[32]}

echo
echo ${select[@]}
echo

romdir="${select[0]}"

if [[ -z ${select[1]} ]];then
romim='Minerva_198a1.bin'
else
basefilename=${select[1]}
ext="${basefilename##*.}"
realname=$(basename "${basefilename%.*}")
sysrom=$realname.$ext
fi

if [[ -z ${select[2]} ]];then
romim=''
else 
basefilename=${select[2]}
ext="${basefilename##*.}"
realname=$(basename "${basefilename%.*}")
romim=$realname.$ext
fi

z=4
if [[ -z ${select[z]} ]];then 
MDV1='#DEVICE = MDV1,'
else
MDV1='DEVICE = MDV1,'${select[z]}',qdos-like'
fi

z=5
if [[ -z ${select[z]} ]];then 
MDV2='#DEVICE = MDV2,'
else
MDV2='DEVICE = MDV2,'${select[z]}',qdos-like'
fi

z=6
if [[ -z ${select[z]} ]];then 
FLP1='#DEVICE = FLP1,'
else
FLP1='DEVICE = FLP1,'${select[z]}',qdos-fs'
fi

z=7
if [[ -z ${select[z]} ]];then 
FLP2='#DEVICE = FLP2,'
else
FLP2='DEVICE = FLP2,'${select[z]}',qdos-fs'
fi

z=8
if [[ -z ${select[z]} ]];then 
WIN1='#DEVICE = WIN1,'
else
WIN1='DEVICE = WIN1,'${select[z]}',qdos-fs'
fi

z=9
if [[ -z ${select[z]} ]];then 
WIN2='#DEVICE = WIN2,'
else
WIN2='DEVICE = WIN2,'${select[z]}',qdos-fs'
fi

z=10
if [[ -z ${select[z]} ]];then 
WIN7='#DEVICE = WIN7,'
else
WIN7='DEVICE = WIN7,'"${select[z]}"
fi

z=11
if [[ -z ${select[z]} ]];then 
WIN8='#DEVICE = WIN8,'
else
WIN8='DEVICE = WIN8,'"${select[z]}"
fi

z=29
if [[ ${select[z]} == 'TRUE' ]];then
select[z]='1'
elif
[[ ${select[z]} == 'FALSE' ]];then
select[z]='0'
fi

z=30
if [[ ${select[z]} == 'TRUE' ]];then
select[z]='1'
elif
[[ ${select[z]} == 'FALSE' ]];then
select[z]='0'
fi

z=31
if [[ ${select[z]} == 'TRUE' ]];then
select[z]='1'
elif
[[ ${select[z]} == 'FALSE' ]];then
select[z]='0'
fi

z=32
if [[ ${select[z]} == 'TRUE' ]];then
select[z]='1'
elif
[[ ${select[z]} == 'FALSE' ]];then
select[z]='0'
fi
prodir=${select[16]}

cat << EOF > $ini
ROMDIR = $romdir
SYSROM = $sysrom
ROMIM = $romim
RAMTOP = ${select[3]}
$MDV1
$MDV2
$FLP1
$FLP2
$WIN1
$WIN2
$WIN7
$WIN8
BOOT_DEVICE = ${select[12]}
RESOLUTION = ${select[13]}
WIN_SIZE = ${select[14]}
KBD = ${select[15]}
FILTER = ${select[29]}
FIXASPECT = ${select[30]}
SOUND = ${select[31]}
CPU_HOG = ${select[32]}
PRODIR = $prodir
EOF

#echo
cat $ini

PROD=$(expand_tilde $prodir)
$PROD/sqlux -f $ini
